/*
    Bantumi
    Copyright 2005, 2006 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __TCPIP_H
#define __TCPIP_H

#include "connection.h"

#define DEFAULT_TCP_PORT 8471

#ifdef WIN32
#include <winsock2.h>
#define SOCKTYPE SOCKET
#else
#define SOCKTYPE int
#endif

void initTCPIP();
void closeTCPIP();

class TCPConnection : public Connection {
public:
	~TCPConnection();

	static TCPConnection *connect(const char *hostName, int port, const char **errString, bool *stop);
	static TCPConnection *accept(int port, const char **errString, bool *stop);
	static TCPConnection *startConnect(const char *hostName, int port, const char **errString);
	static TCPConnection *startAccept(int port, const char **errString);
	int pollConnect(int msec, const char **errString);
	int pollAccept(int msec, const char **errString);

	bool isClient();
	int ready(const char **errString);
	bool read(const char **errString);
	bool write(const unsigned char *ptr, int n, const char **errString);

private:
	TCPConnection(int s);
	SOCKTYPE sock;
	int status;
	bool connecting;
	bool client;
};

#endif
